; 15(b) Develop and execute an Assembly Language program to drive the
;        Elevator interface in the following way:
; Assume that initialy the elevator is at ground floor and all service
; requests are cleared. The elevator stays in the ground floor as long as
; there is no service request.When a service request is detected,
;  the elevator moves to that floor. While it is traveling to that floor, all
;  other service request are ignored. After servicing that floor, it scans
;  for further request for sometime( student can setup a suitable time; no
;   need to calculate the exact value) If no request is detected within this
;   time, the elevator travels to the ground floor ignoring any further
;   request.On the other hand if a request is detected while it is scanning
;   for requests, it moves to that floor, again ignoring any other intermediate
;   requests during the travel. If more than one request is detected at the
;   same time, a floor is selected arbitrarily.
;       The delays to simulate the elevator motion, the delay indicating
;   the servicing of a request can be any arbitrary values. Examiner doesn't
;   specify these values, nor is the student required to calculate them.
  .MODEL SMALL
  .STACK
  .DATA
     R  DB  00H,03H,06H,09H,0E0H,0D3H,0B6H,079H
     PA  EQU   120H
     PB  EQU   121H
     PC  EQU   122H
     CR  EQU   123H
     X  DB 2
  .CODE
        MOV AX,@DATA
        MOV DS,AX     ;Initialize data segment
        MOV DX,CR
        MOV AL,82H
        OUT DX,AL     ;Initialize 8255 PPI
        MOV BL,0
        MOV AL,BL
        OR AL,0F0H
        MOV DX,PA
        OUT DX,AL
    CHK:MOV DX,PB    
        IN AL,DX     ;Read the request from the Elevator
        OR AL,0F0H
        CMP AL,0FFH
        JZ CHK
  START:LEA SI,R
   BACK:ROR AL,1
        JNC DECIDE    ;if carry flag is reset there will be request
        INC SI        
        JMP BACK
 DECIDE:CALL DELAY
        CMP [SI],BL
        JZ RESET
        JS DOWN
        INC BL
        MOV AL,BL    ;Move elevator Upwards
        OR AL,0F0H
        MOV DX,PA
        MOV DX,PA
        OUT DX,AL
        JMP DECIDE
  DOWN: DEC BL
        MOV AL,BL
        OR AL,0F0H
        MOV DX,PA      ;Move elevator Downwards
        OUT DX,AL
        JMP DECIDE
  RESET:MOV AX,4
        ADD SI,AX
        MOV AL,[SI]
        MOV DX,PA          ;Reset the requst indicator
        OUT DX,AL
        DEC X
        JNZ WAIT1
    GND:CMP BL,0
        JZ EXIT
        DEC BL
        MOV AL,BL           ;Bring the elevator to ground floor
        OR AL,0F0H
        MOV DX,PA
        OUT DX,AL
        CALL DELAY
        JMP GND
   EXIT:MOV AH,4CH
        INT 21H
   DELAY:PUSH BX
         PUSH CX
         MOV BX,0099H
      B2:MOV CX,0FFFFH
      B1:LOOP B1
         DEC BX
         JNZ B2
         POP CX
         POP BX
         RET
   WAIT1:PUSH BX
         PUSH CX
         MOV BX,0020H
     B22:MOV CX,0FFFFH
     B11:MOV DX,PB
         IN AL,DX
         OR AL,0F0H
         CMP AL,0FFH
         JNZ RETRIVE
         LOOP B11
         DEC BX
         JNZ B22
         POP CX
         POP BX
         JMP GND
 RETRIVE:POP CX
         POP BX
         JMP START
         END



